<template lang="pug">
  div.mb-12
    v-card.mb-12
      v-card-title Sites
      v-card-text
        v-data-table(
          :headers="headers"
          :items="getAllSite.data"
          :items-per-page="10"
          class="elevation-0"
          v-model="selected"
          show-select
          single-select
          @click:row="rowClick"
        )
        v-btn#deleteSiteButton.float-left(
          color="warning"
        ) Delete
        v-btn#editSiteButton.float-right(
          @click="setEditSite"
          color="success"
        ) Edit
      v-fab-transition
        v-btn#newSiteButton(
          color="success"
          bottom
          right
          large
          fixed
          fab
        )
          v-icon mdi-plus-circle-outline
    v-dialog(
      v-model="showModal"
      activator="#newSiteButton"
      persistent
    )
      v-card
        v-card-title New Site
        v-card-text
          v-text-field(
            label="Site Number"
            v-model.number="newSite.number"
          )
          v-textarea(
            label="Location"
            v-model="newSite.location"
          )
          div.d-flex
            v-btn.ml-auto(
              color="warning"
              @click="showModal = false"
            ) Cancel
            v-btn.ml-3(
              color="success"
              @click="saveNewSite"
            ) Save
    v-dialog(
      v-model="showEditModal"
      activator="#editSiteButton"
      persistent
    )
      v-card
        v-card-title Edit Site
        v-card-text
          v-text-field(
            label="Site Number"
            v-model.number="editSite.number"
          )
          v-textarea(
            label="Location"
            v-model="editSite.location"
          )
          div.d-flex
            v-btn.ml-auto(
              color="warning"
              @click="showEditModal = false"
            ) Cancel
            v-btn.ml-3(
              color="success"
              @click="saveEditSite"
            ) Save
    v-dialog(
      v-model="areYouSure"
      activator="#deleteSiteButton"
    )
      v-card
        v-card-title Are You Sure?
        v-card-text Deleting a Site removes all associated Contexts and
          b cannot be undone!
          div.d-flex.mt-3
            v-btn(
              color="success"
              @click="areYouSure = false"
            ) No! Don't Delete!
            v-btn.ml-auto(
              color="warning"
              @click="deleteSite"
            ) I'm Sure.
    v-snackbar.text-center(
      v-model="snackbar"
      persistent
    ) {{ notification }}
</template>

<script>
import { mapGetters, mapActions, mapMutations } from "vuex";

export default {
    name: "sites-collection",
    props: {
        projectid: {
            required: true,
            type: String
        }
    },
    data() {
        return {
            headers: [
                { text: "Site Number", value: "attributes.number" },
                { text: "Location", value: "attributes.location" }
            ],
            snackbar: false,
            notification: null,
            areYouSure: false,
            showModal: false,
            showEditModal: false,
            newSite: {
                number: null,
                location: null
            },
            editSite: {
                number: null,
                location: null
            },
            selected: []
        };
    },
    created() {
        this.$store.dispatch("getCurrentURL", { projectID: this.projectid });
    },
    computed: {
        ...mapGetters("site", ["getAllSite"]),
        ...mapGetters("project", ["getAProject"])
    },
    methods: {
        ...mapActions("site", {
            fetchAllSite: "fetchAllSite",
            createASite: "createASite",
            putASite: "putASite",
            deleteASite: "deleteASite"
        }),
        ...mapMutations(["setNotification"]),
        rowClick(row) {
            this.$router.push({ path: `site/${row.id}/trenchs` });
        },
        setEditSite() {
            if (this.selected.length > 0) {
                this.editSite.proiect = this.currentProject;
                this.editSite.number = this.selected[0].attributes.number;
                this.editSite.location = this.selected[0].attributes.location;
            }
        },
        saveEditSite() {
            this.putASite({
                url: this.selected[0].links.self,
                payload: this.editSite
            }).then(response => {
                this.fetchAllSite({ url: this.getAllSite.links.self });
                this.setNotification("Site Saved");
            });
        },
        deleteSite() {
            if (this.selected.length > 0) {
                this.deleteASite(this.selected[0].links.self).then(response => {
                    this.fetchAllSite({ url: this.getAllSite.links.self });
                    this.setNotification("Site Deleted");
                    this.areYouSure = false;
                });
            } else {
                this.setNotification("No Site Selected for Deletion");
                this.areYouSure = false;
            }
        },
        saveNewSite() {
            this.createASite({
                url: this.getAllSite.links.self,
                payload: this.newSite
            }).then(response => {
                this.fetchAllSite({ url: this.getAllSite.links.self });
                this.setNotification("Site Created");
                this.showModal = false;
            });
        }
    }
};
</script>
